from FX import *


convolve2x1D = Cg("""
void vs(float4 position : POSITION,
        float2 texcoord : TEXCOORD,

    out float4 oPosition : POSITION,
    out float2 oTexcoord0 : TEXCOORD0,
    out float2 oTexcoord1 : TEXCOORD1,

uniform float2 OffsetDir,
uniform float2 OffsetLength,
uniform float4x4 ModelViewProj)
{
   oPosition = position; //mul(ModelViewProj,position);
   oTexcoord0 = texcoord + OffsetLength.x*OffsetDir; 
   oTexcoord1 = texcoord + OffsetLength.y*OffsetDir;
}

void ps(float2 texcoord0 : TEXCOORD0,
        float2 texcoord1 : TEXCOORD1,
        float4 color : COLOR,
          
    out float4 oColor : COLOR,

uniform float2 Coefficients,
uniform samplerRECT Source)
{
   oColor  = Coefficients.x*texRECT(Source, texcoord0);
   oColor += Coefficients.y*texRECT(Source, texcoord1);
}""")

convolve4x1D = Cg("""
void vs(float4 position : POSITION,
        float2 texcoord : TEXCOORD,

    out float4 oPosition : POSITION,
    out float2 oTexcoord0 : TEXCOORD0,
    out float2 oTexcoord1 : TEXCOORD1,
    out float2 oTexcoord2 : TEXCOORD2,
    out float2 oTexcoord3 : TEXCOORD3,

uniform float2 OffsetDir,
uniform float4 OffsetLength,
uniform float4x4 ModelViewProj)
{
   oPosition = position; //mul(ModelViewProj,position);
   oTexcoord0 = texcoord + OffsetLength.x*OffsetDir; 
   oTexcoord1 = texcoord + OffsetLength.y*OffsetDir;
   oTexcoord2 = texcoord + OffsetLength.z*OffsetDir;
   oTexcoord3 = texcoord + OffsetLength.w*OffsetDir;
}

void ps(float2 texcoord0 : TEXCOORD0,
        float2 texcoord1 : TEXCOORD1,
        float2 texcoord2 : TEXCOORD2,
        float2 texcoord3 : TEXCOORD3,

    out float4 oColor : COLOR,

uniform float4 Coefficients,
uniform samplerRECT Source)
{
   oColor  = Coefficients.x*texRECT(Source, texcoord0);
   oColor += Coefficients.y*texRECT(Source, texcoord1);
   oColor += Coefficients.z*texRECT(Source, texcoord2);
   oColor += Coefficients.w*texRECT(Source, texcoord3);
}""")


convolve3x3FS = Cg("""
float4 main(float2 texcoords : TEXCOORD,
            uniform samplerRECT Source,
            uniform float3x3 Kernel,
            uniform float Sum,
            uniform float2 Direction0,
            uniform float2 Direction1) : COLOR
{
   float2 tc = texcoords + Direction1;
   float4 c00 = texRECT(Source, tc - Direction0);
   float4 c01 = texRECT(Source, tc             );
   float4 c02 = texRECT(Source, tc + Direction0);

   
   float4 c10 = texRECT(Source, texcoords - Direction0             );
   float4 c11 = texRECT(Source, texcoords                          );
   float4 c12 = texRECT(Source, texcoords + Direction0             );

   tc = texcoords - Direction1;
   float4 c20 = texRECT(Source, tc - Direction0);
   float4 c21 = texRECT(Source, tc             );
   float4 c22 = texRECT(Source, tc + Direction0);

   c00 *= Kernel._m00;
   c01 *= Kernel._m01;
   c02 *= Kernel._m02;
   c10 *= Kernel._m00;
   c11 *= Kernel._m01;
   c10 *= Kernel._m02;
   c20 *= Kernel._m00;
   c21 *= Kernel._m01;
   c22 *= Kernel._m02;

   return (c00+c01+c02+c10+c11+c12+c20+c21+c22)/Sum;
}
""")
