
from FX import *
from math import sqrt

SpecularRollOff = 0.01
Ecc = (1.0,1.0,1.0,1)
Gain = 0.35
LightDirection = (1/sqrt(3), 1/sqrt(3), 1/sqrt(3))
LightColor = ( 1, 1, 1, 1 )

vs = Cg( """
void main(float4 position : POSITION,
          float3 normal   : NORMAL,

      out float4 oPosition : POSITION,
      out float4 color     : COLOR,
      
  uniform float4x4 ModelView,
  uniform float4x4 Projection,
  uniform float4x4 ModelViewIT,
  uniform float    SpecularRollOff,
  uniform float4   Ecc,
  uniform float    Gain,
  uniform float3   LightDirection,
  uniform float4   LightColor)
{
  float4 worldPos = mul(ModelView, position);
  float3 worldNormal = normalize(mul((float3x3)ModelViewIT, normal));
  float VdH = max(dot(LightDirection, worldNormal),0);
  float specRollOffEdge = pow(VdH, 1.0);
  float rollOff = specRollOffEdge + (1.0 - specRollOffEdge)*SpecularRollOff;

  oPosition = mul(Projection, worldPos);
  color = LightColor*Ecc*Gain*rollOff;
  //color = float4(rollOff.xxx,1);
}""")

technique = [Render(ZEnable = True,
                    CullMode = None,
                    VertexShader = vs())]

